'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.update = exports.rater = exports.init = undefined;

var _immutable = require('immutable');

var init = function init(initial, observe) {
  return {
    initial: initial, observe: observe, values: new _immutable.Map()
  };
};


var rater = function rater(_ref, game) {
  var initial = _ref.initial,
      observe = _ref.observe,
      values = _ref.values;
  return function (action) {
    return values.getIn([observe(game), action], initial);
  };
};

var update = function update(_ref2, game, action, updater) {
  var initial = _ref2.initial,
      observe = _ref2.observe,
      values = _ref2.values;
  return {
    initial: initial, observe: observe, values: values.updateIn([observe(game), action], initial, updater)
  };
};

exports.init = init;
exports.rater = rater;
exports.update = update;
